<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: infusion.php for RSS Parser System
| Author: Stewart-G0LGS (A G S Wilkinson)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------+
| Note: This Package includes other works distributed under
| GNU General Public License (GPL) as published by 
| the Free Software Foundation
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

include INFUSIONS."rss_parser_panel/infusion_db.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."rss_parser_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."rss_parser_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."rss_parser_panel/locale/English.php";
}

// General information
$inf_title = $locale['rssp_title'];
$inf_description = $locale['rssp_desc'];
$inf_version = $rssp_version;
$inf_developer = "Stewart-G0LGS (AGS Wilkinson)";
$inf_email = "php@g0lgs.co.uk";
$inf_weburl = "http://www.g0lgs.co.uk/downloads.php";

// The folder in which the infusion resides.
$inf_folder = "rss_parser_panel"; 

// Create Tables

// New Table Structure
$inf_altertable[1] = DB_RSSPANEL." ADD feed_show_desc SMALLINT(2) UNSIGNED NOT NULL DEFAULT '1'";
$inf_altertable[2] = DB_RSSPANEL. " CHANGE feed_url feed_url VARCHAR( 512 ) NOT NULL DEFAULT ''";
$inf_altertable[3] = DB_RSSPANEL." ADD feed_show_feedname SMALLINT(2) UNSIGNED NOT NULL DEFAULT '1'";
$inf_altertable[4] = DB_RSSPANEL." ADD feed_show_pubdate SMALLINT(2) UNSIGNED NOT NULL DEFAULT '1'";
$inf_altertable[5] = DB_RSSPANEL." ADD feed_show_more SMALLINT(2) UNSIGNED NOT NULL DEFAULT '1'";

// Feeds
$inf_newtable[1] = DB_RSSPANEL." (
  feed_id SMALLINT(2) UNSIGNED NOT NULL AUTO_INCREMENT,
  feed_name VARCHAR(30) NOT NULL DEFAULT '',
  feed_url VARCHAR(512) NOT NULL DEFAULT '',
  feed_linkname VARCHAR(30) NULL DEFAULT NULL,
  feed_rows SMALLINT(2) UNSIGNED NOT NULL DEFAULT '5',
  feed_cache SMALLINT(2) UNSIGNED NOT NULL DEFAULT '1200',
  feed_newwin SMALLINT(2) UNSIGNED NOT NULL DEFAULT '0',
  feed_show_desc SMALLINT(2) UNSIGNED NOT NULL DEFAULT '0',
  feed_show_feedname SMALLINT(2) UNSIGNED NOT NULL DEFAULT '0',
  feed_show_pubdate SMALLINT(2) UNSIGNED NOT NULL DEFAULT '0',
  feed_show_more SMALLINT(2) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (feed_id)
) ENGINE=MyISAM;";

// Sample Feeds
/*$inf_insertdbrow[1] = DB_RSSPANEL." (feed_id, feed_name, feed_url, feed_linkname, feed_rows, feed_cache, feed_newwin, feed_show_desc, feed_show_feedname, feed_show_pubdate, feed_show_more ) VALUES
	(1, 'BBC News', 'http://feeds.bbci.co.uk/news/rss.xml?edition=int', 'BBC News', 5, 3600, 1, 0, 1, 1, 1),
	(2, 'BBC Local Weather', 'http://newsrss.bbc.co.uk/weather/forecast/2174/Next3DaysRSS.xml', '', 5, 3600, 1, 1, 1, 1, 1)
";*/

// Determine Panel Orders
$rssp_left=1; // Left
$rssp_cnup=2; // Center Up
$rssp_cndn=3; // Center Down
$rssp_rght=4; // Right

// Find new Panel Order (Left)
$rssp_res = dbquery("SELECT * FROM ".DB_PANELS." WHERE panel_side='".$rssp_left."' ORDER BY panel_order DESC LIMIT 1");
if (dbrows($rssp_res) != 0) { $rssp_data = dbarray($rssp_res); $rssp_newleft = $rssp_data['panel_order'] + 1; } else { $rssp_newleft = 1; }

// Find new Panel Order (Center Up)
$rssp_res = dbquery("SELECT * FROM ".DB_PANELS." WHERE panel_side='".$rssp_cnup."' ORDER BY panel_order DESC LIMIT 1");
if (dbrows($rssp_res) != 0) { $rssp_data = dbarray($rssp_res); $rssp_newcnup = $rssp_data['panel_order'] + 1; } else { $rssp_newcnup = 1; }

// Find new Panel Order (Center Down)
$rssp_res = dbquery("SELECT * FROM ".DB_PANELS." WHERE panel_side='".$rssp_cndn."' ORDER BY panel_order DESC LIMIT 1");
if (dbrows($rssp_res) != 0) { $rssp_data = dbarray($rssp_res); $rssp_newcndn = $rssp_data['panel_order'] + 1; } else { $rssp_newcndn = 1; }

// Find new Panel Order (Right)
$rssp_res = dbquery("SELECT * FROM ".DB_PANELS." WHERE panel_side='".$rssp_rght."' ORDER BY panel_order DESC LIMIT 1");
if (dbrows($rssp_res) != 0) { $rssp_data = dbarray($rssp_res); $rssp_newrght = $rssp_data['panel_order'] + 1; } else { $rssp_newrght = 1; }


//Fix Icon in Admin Panel (added V0.7.2)
$rssp_res = dbquery("UPDATE ".DB_ADMIN." SET admin_image='admin_rss.gif' WHERE admin_link='".INFUSIONS."rss_parser_panel/rss_parser_panel_admin.php'");


// Add Default Panels
/*$inf_insertdbrow[2] = DB_PANELS." 
	(panel_name, panel_filename, panel_content, panel_side, panel_order, panel_type, panel_access, panel_display, panel_status) VALUES 
	('BBC News',		'rss_parser_panel', '', '$rssp_left', '$rssp_newleft++',	'file', '0', '0', '1'),
	('BBC Local Weather',	'rss_parser_panel', '', '$rssp_cndn', '$rssp_newcndn++',	'file', '0', '0', '1')
";*/

// Drop Table
$inf_droptable[1] = DB_RSSPANEL;

// Remove Panel(s)
$inf_deldbrow[1] = DB_PANELS." WHERE panel_filename='rss_parser_panel'";

// The Administrators Panel
$inf_adminpanel[1] = array(
	"title" => $locale['rssp_admin1'],
	"image" => "admin_rss.gif",
	"panel" => "rss_parser_panel_admin.php",
	"rights" => "RSP"
);

?>
