<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: rss_parser_panel.php for RSS Parser System
| Author: Stewart-G0LGS (A G S Wilkinson)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------+
| Note: This Package includes other works distributed under
| GNU General Public License (GPL) as published by
| the Free Software Foundation
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

// Panel Info from Php-Fusion
global $p_data;

include INFUSIONS."rss_parser_panel/infusion_db.php";
require_once INFUSIONS."rss_parser_panel/functions.php";
require_once INFUSIONS."rss_parser_panel/lastRSS.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."rss_parser_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."rss_parser_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."rss_parser_panel/locale/English.php";
}

// All Feeds ?
if( strcasecmp($p_data['panel_name'], $locale['rssp_110']) ==0 ){
	// Get All Feed Parameters from DB
	$rssp_res = dbquery("SELECT * FROM ".DB_RSSPANEL." WHERE 1" );
}else{
	// Get Feed Parameters from DB
	$rssp_res = dbquery("SELECT * FROM ".DB_RSSPANEL." WHERE feed_name = '". $p_data['panel_name']."' LIMIT 0,1" );
}

// Number of Rows
if( $rssp_res ) {
	$rssp_rows = dbrows($rssp_res);
}

// Not Found / No Results
if( (!$rssp_res) or ($rssp_rows == 0) ) {
	if( ($p_data['panel_side'] == 1) or ($p_data['panel_side'] == 4 ) ) {
		openside($p_data['panel_name'], true, "on" );
		echo "<p>".$locale['rssp_001']."</p>";
		closeside();
	}else{
        	opentable($p_data['panel_name']);
		echo "<p>".$locale['rssp_001']."</p>";
		closeside();
	}
	return False;

}else{
	while( $rssp_data = dbarray($rssp_res) ){

		$rssp_feed_name = $rssp_data['feed_name'];	// Should be = $p_data['panel_name']
		$rssp_feed_url = $rssp_data['feed_url'];
		$rssp_feed_rows = $rssp_data['feed_rows'];
		$rssp_feed_cache = $rssp_data['feed_cache'];
		$rssp_feed_newwin = $rssp_data['feed_newwin'];
		$rssp_feed_linkname =  isset($rssp_data['feed_linkname']) ? $rssp_data['feed_linkname'] : "";
		$rssp_feed_show_desc = isset($rssp_data['feed_show_desc']) ? $rssp_data['feed_show_desc'] : 0;
		$rssp_feed_show_feedname = isset($rssp_data['feed_show_feedname']) ? $rssp_data['feed_show_feedname'] : 0;
		$rssp_feed_show_pubdate = isset($rssp_data['feed_show_pubdate']) ? $rssp_data['feed_show_pubdate'] : 0;
		$rssp_feed_show_more = isset($rssp_data['feed_show_more']) ? $rssp_data['feed_show_more'] : 0;

		// Create lastRSS object
		$rss = new lastRSS;

		// Configue lastRSS
		$rss->cache_dir = INFUSIONS."rss_parser_panel/cache";

		// Extract CDATA Fields
		$rss->CDATA = 'content';

		// Do not Strip HTML
		$rss->stripHTML = False;

		// No Not Convert CodePage
		$rss->cp = '';

		// No Date Conversion
		$rss->date_format = '';

		//
		// Process Feed.
		//

		// Set Cache Time
		$rss->cache_time = $rssp_feed_cache;

		// Get & Display Feed
		if( $rs = $rss->get($rssp_feed_url) ) {

			// Panel Location
			if( ($p_data['panel_side'] == 1) or ($p_data['panel_side'] == 4 ) ) {
				$RSS_Center=False;
				if( ($rssp_feed_show_feedname == 1) and $rs['title'] ){
					openside( $rs['title'], true, "on" );
				}else{
					openside( $rssp_data['feed_name'], true, "on" );
				}
			}else{
				$RSS_Center=True;
				if( ($rssp_feed_show_feedname == 1) and $rs['title'] ){
	        			opentable( $rs['title'] );
				}else{
		        		opentable( $rssp_data['feed_name'] );
				}
			}

			if( $RSS_Center ){
				echo "<table width='100%'>\n";
			}
			$cnt=0;
			foreach( $rs['items'] as $item ) {

				if( $RSS_Center ){
					echo "<tr>\n<td class='main-body middle-border'>\n";
				}else{
					echo "<span class='bullet'>&middot;</span>";
				}


				if( ($rssp_feed_show_pubdate == 1) and isset($item['pubDate']) and ($item['pubDate']) and ($pubDate = strtotime($item['pubDate']) ) ) {

					if( $RSS_Center ){
						if( isset($item['link']) ){
							echo " <a href='".$item['link']."' title='".$p_data['panel_name'].": ".date("H:i d/m/Y",$pubDate);
							echo ": ".html_entity_decode(phpentities($item['title']))."'";

							if( $rssp_feed_newwin == 1 ) { echo " target='_blank'"; }
							echo ">".html_entity_decode($item['title'])."</a>\n";

							if( ($rssp_feed_show_desc == 1) and isset($item['description']) ) {
								echo "<br />".$item['description']."<br /><br />\n";
							}
						}else{
							echo "&nbsp;". html_entity_decode($item['title']);
						}
					}else{
						if( isset($item['link']) ){
							echo " <a href='".$item['link']."' title='".$p_data['panel_name'].": ".date("H:i d/m/Y",$pubDate);
							if( isset($item['description']) ){
								echo ": ".trimtext($item['description'],50);
							}
							echo "'";

							if( $rssp_feed_newwin == 1 ) { echo " target='_blank'"; }
							echo ">".html_entity_decode(phpentities($item['title']))."</a>\n";

							if( ($rssp_feed_show_desc == 1) and isset($item['description']) ) {
								echo "<br />".$item['description']."<br /><br />\n";
							}
						}else{
							echo "&nbsp;". html_entity_decode($item['title']);
						}
					}
				}else{
					if( $RSS_Center ){
						if( isset($item['link']) ){
							echo " <a href='".$item['link']."' title='".$p_data['panel_name'].": ";
							echo html_entity_decode(phpentities($item['title']))."'";

							if( $rssp_feed_newwin == 1 ) { echo " target='_blank'"; }
							echo ">".html_entity_decode($item['title'])."</a>\n";

							if( ($rssp_feed_show_desc == 1) and isset($item['description']) ) {
								echo "<br />".$item['description']."<br /><br />\n";
							}
						}else{
							echo "&nbsp;". html_entity_decode($item['title']);
						}
					}else{
						if( isset($item['link']) ){
							echo " <a href='".$item['link']."' title='".$p_data['panel_name'].": ";
							if( isset($item['description']) ){
								echo trimtext($item['description'],50);
							}
							echo "'";

							if( $rssp_feed_newwin == 1 ) { echo " target='_blank'"; }
							echo ">".html_entity_decode(phpentities($item['title']))."</a>\n";

							if( ($rssp_feed_show_desc == 1) and isset($item['description']) ) {
								echo "<br />".$item['description']."<br /><br />\n";
							}
						}else{
							echo "&nbsp;". html_entity_decode($item['title']);
						}

					}
				}

				if( $RSS_Center ){
					echo "</td>\n</tr>";
				}else{
					echo "<br />\n";
				}

				// Ensure only MaxRows Displayed
				$cnt++;
				if( $cnt == $rssp_feed_rows ){
					break;
				}
			}
			unset($item);


			if ($rs['items_count'] <= 0){
				if( $RSS_Center ){ echo "<tr>\n<td class='main-body middle-border'>\n"; }
				echo $locale['rssp_002'];
				if( $RSS_Center ){ echo "</td>\n</tr>"; }
			}

			// Site Link
			if( ($rssp_feed_show_more == 1) and $rs['link'] ){
				if( $RSS_Center ){ echo "<tr>\n<td class='main-body middle-border'>\n"; }else{ echo "<br />"; }
				echo "<a href='".$rs['link']."' ";
				if( isset($rs['description']) ){
					echo " title='". htmlentities($rs['description'],ENT_QUOTES). "' ";
				}
				if( $rssp_feed_newwin == 1 ) { echo " target='_blank'"; }
				echo "> ".$locale['rssp_130'];
				if( $rssp_feed_linkname ){
					echo $rssp_feed_linkname;
				}else{
					echo $rssp_feed_name;
				}
				echo " ...</a>\n";
				if( $RSS_Center ){ echo "</td>\n</tr>"; }
			}

			unset($rs);

			if( $RSS_Center ){ echo "</table>"; }

			if( ($p_data['panel_side'] == 1) or ($p_data['panel_side'] == 4 ) ) {
				closeside();
			}else{
        			closetable();
			}

		}else{
			// Problem with RSS Feed.

			if( ($p_data['panel_side'] == 1) or ($p_data['panel_side'] == 4 ) ) {
				openside($p_data['panel_name']);
			}else{
        			opentable($p_data['panel_name']);
			}

			echo "<p>".$locale['rssp_020']."</p>\n";

			if( ($p_data['panel_side'] == 1) or ($p_data['panel_side'] == 4 ) ) {
				closeside();
			}else{
        			closetable();
			}
		}

		unset($rss);

	}// while
}

?>
