<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: rss_parser_panel_admin.php for RSS Parser System
| Author: Stewart-G0LGS (A G S Wilkinson)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------+
| Note: This Package includes other works distributed under
| GNU General Public License (GPL) as published by
| the Free Software Foundation
+--------------------------------------------------------*/

require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";

include INFUSIONS."rss_parser_panel/infusion_db.php";

if (!checkrights("RSP") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("/index.php"); }

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."rss_parser_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."rss_parser_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."rss_parser_panel/locale/English.php";
}

$feed_id=0;
$RSSPErrMsg="";

if( isset($_GET['status']) ) {
	$status=stripinput($_GET['status']);

	if ( $status == "sn") {
		$message = $locale['rssp_sn'];
	} elseif ( $status == "su") {
		$message = $locale['rssp_su'];
	} elseif ( $status == "cl") {
		$message = $locale['rssp_cl'];
	} elseif ( $status == "ce") {
		$message = $locale['rssp_ce'];
	} elseif ( $status == "nc") {
		$message = $locale['rssp_nc'];
	} elseif ( $status == "dl") {
		$message = $locale['rssp_dl'];
	}
	if ($message) { echo "<div id='close-message'><div class='admin-message'>".$message."</div></div>\n"; }
}

//
// Please DO NOT remove this Section. It is the only place in
// my work that displays my information and a link for you the
// PHP-Fusion System Administrator to be able to easily find the
// latest Version or any extra information that I may publish
// about the RSS Parser System.
//

opentable($locale['rssp_title']." V".$rssp_version." (".$rssp_verdate.")");
echo "<table>\n";
echo "<tr>";
echo "<td rowspan='3'><img style='margin: 7px;' src='".BASEDIR."administration/images/admin_rss.gif' alt='RSS Admin' title='RSS Admin'></td>";
echo "<td>Copyright &copy; 2011-2012 by Stewart Wilkinson G0LGS (";
echo hide_email('php@g0lgs.co.uk','','RSS-Parser-System').")</td>";
echo "</tr>\n";

echo "<tr><td>".$locale['rssp_see']." <a href='http://www.g0lgs.co.uk/soft_vers.php?AppName=rssparser&amp;Vers=";
echo $rssp_version."' target='_blank'>http://www.g0lgs.co.uk</a>";
echo $locale['rssp_forupd']."</td></tr>\n";

if( ! is_writable( INFUSIONS."rss_parser_panel/cache/" ) ){

	$msg = str_replace("[CACHE_FOLDER]", INFUSIONS."rss_parser_panel/cache/", $locale['rssp_150']);
	echo "<tr><td style='color:red;'><strong>".$msg."</strong></td></tr>\n";
}else{
	echo "<tr><td style='color:green;'><strong>".$locale['rssp_151']."</strong></td></tr>\n";
}
echo "</table>\n";
closetable();

if(isset($_GET['action'])) {
	$action = stripinput($_GET['action']);
} else {
	$action = '';
}

// Clear Selected Cache
if( $action == 'clear' ){
	if( isset($_GET['feed_id']) ){
		$feed_id = stripinput($_GET['feed_id']);

		// Get Feed info from DB
		$rssp_res = dbquery( "SELECT * FROM ".DB_RSSPANEL." WHERE feed_id='".$feed_id."'" );

		if( dbrows($rssp_res) != 0 ){
			// Get Row Info
			$rssp_data = dbarray($rssp_res);

			$cachefile = INFUSIONS."rss_parser_panel/cache/rsscache_" . md5($rssp_data['feed_url']);
			if( file_exists( $cachefile ) ) {
				if( unlink( $cachefile ) ){
					$rssp_status="&amp;status=cl";
				}else{
					$rssp_status="&amp;status=ce";
				}
			}else{
				$rssp_status="&amp;status=nc";
			}
		}

		// Refresh Page
		redirect(FUSION_SELF.$aidlink.$rssp_status);
	}else{
		// Refresh Page
		redirect(FUSION_SELF.$aidlink);
	}

// Clear All Cache
}elseif( $action == 'clearall' ){

	$rssp_status="&amp;status=nc";

	$cachefiles = INFUSIONS."rss_parser_panel/cache/rsscache_*";
	foreach( glob($cachefiles) as $fn) {
		if( unlink($fn) ) {
			$rssp_status="&amp;status=cl";
		}else{
			$rssp_status="&amp;status=ce";
		}
	}

	// Redirect
	redirect(FUSION_SELF.$aidlink.$rssp_status);

//
// Delete Feed from List, Remove Cache, Remove Related Panels
//
}elseif( $action == 'delete' ){
	if( isset($_GET['feed_id']) ){
		$feed_id = stripinput($_GET['feed_id']);

		// Get Feed info from DB
		$rssp_res = dbquery( "SELECT * FROM ".DB_RSSPANEL." WHERE feed_id='".$feed_id."'" );

		if( dbrows($rssp_res) != 0 ){
			// Get Row Info
			$rssp_data = dbarray($rssp_res);
			$rssp_name = $rssp_data['feed_name'];

			// Remove Cache
			$cachefile = INFUSIONS."rss_parser_panel/cache/rsscache_" . md5($rssp_data['feed_url']);
			if( file_exists( $cachefile ) ) {
				unlink( $cachefile );
			}

			// Drop Feed from DB
			$result = dbquery( "DELETE FROM ".DB_RSSPANEL." WHERE feed_id='".$feed_id."'" );

			// Drop Related Panels
			if( $rssp_name and ($rssp_name != '') ){
				$rssp_res = dbquery( "DELETE FROM ".DB_PANELS." WHERE panel_name='".$rssp_name."' AND panel_filename = 'rss_parser_panel'" );
			}

			if( $result and $rssp_res ){
				$rssp_status="&amp;status=dl";
			}
		}

		// Refresh Page
		redirect(FUSION_SELF.$aidlink.$rssp_status);
	}else{
		// Refresh Page
		redirect(FUSION_SELF.$aidlink);
	}

// Update Existing Feed
}elseif( $action == 'update' ){

	$rss_formaction = FUSION_SELF.$aidlink."&action=update";

	$feed_id = stripinput($_POST['feed_id']);

	$feed_name = stripinput($_POST['feed_name']);
	$feed_url  = stripinput($_POST['feed_url']);
	$link_name = stripinput($_POST['link_name']);
	$feed_rows = stripinput($_POST['feed_rows']);
	$cache_time= stripinput($_POST['cache_time']);
	$new_window= isset($_POST['new_window']) ? 1:0;
	$use_desc  = isset($_POST['use_desc']) ? 1:0;
	$use_fname = isset($_POST['use_fname']) ? 1:0;
	$use_pdate = isset($_POST['use_pdate']) ? 1:0;
	$use_more = isset($_POST['use_more']) ? 1:0;
	$panel_loc = isset($_POST['location']) ? stripinput($_POST['location']) : "" ;
	$panel_acc = isset($_POST['access']) ? stripinput($_POST['access']) : "" ;

	// Feed Name OK ?
	if( (strlen($feed_name) < 3) ) {
		$RSSPErrMsg .= $locale['rssp_bfname'] ."<br />";
	}

	// Feed URL OK ?
	if( (strlen($feed_url) < 10) ) {
		$RSSPErrMsg .= $locale['rssp_bfurl'] ."<br />";
	}

	// Cache Time Ok ?
	if( ($cache_time < 300) or ($cache_time > 604800) ) { // 5 Mins to 1 Week
		$RSSPErrMsg .= $locale['rssp_bfcache'] ."<br />";
	}

	if( ! $RSSPErrMsg ) {

		// GET Old Panel Details
		$rssp_res = dbquery( "SELECT feed_name FROM ".DB_RSSPANEL." WHERE feed_id='".$feed_id."'" );
		$rssp_data = dbarray($rssp_res);
		$rssp_pname = $rssp_data['feed_name'];

		// Rename Panel ??
		if( $feed_name != $rssp_pname ){
			$SQL1 = "UPDATE ".DB_PANELS." SET
			panel_name = '".$feed_name."'
			WHERE panel_name = '".$rssp_pname."' AND panel_filename = 'rss_parser_panel'";
		}

		$SQL2 = "UPDATE ".DB_RSSPANEL." SET
		feed_name = '".$feed_name."',
		feed_url = '".$feed_url."',
		feed_linkname = '".$link_name."',
		feed_rows = '".$feed_rows."',
		feed_cache = '".$cache_time."',
		feed_newwin = '".$new_window."',
		feed_show_desc = '".$use_desc."',
		feed_show_feedname = '".$use_fname."',
		feed_show_pubdate = '".$use_pdate."',
		feed_show_more = '".$use_more."'
		WHERE feed_id='".$feed_id."'";

		if( ($result = dbquery($SQL2) ) ) {
			if( isset($SQL1) ){
				$result2 = dbquery($SQL1);
			}
		}

		$rssp_status="&amp;status=su";
		redirect(FUSION_SELF.$aidlink.$rssp_status);
	}

	// Get Current Panel Location / Access
	$rssp_res = dbquery( "SELECT * FROM ".DB_PANELS." WHERE panel_name='".$feed_name."' AND panel_filename = 'rss_parser_panel'" );
	$rssp_data = dbarray($rssp_res);
	$loc = $rssp_data['panel_side'];
	$access = $rssp_data['panel_access'];

	$readonly = " disabled='disabled' ";
	$noedit = str_replace("[PANEL_EDITOR]", "<a href='".BASEDIR."administration/panels.php".$aidlink
	."'>".$locale['rssp_131']."</a>", $locale['rssp_noedit']);

	opentable($locale['rssp_edit']);

// Add new Feed
}elseif( $action == 'addfeed' ){

	$rss_formaction = FUSION_SELF.$aidlink."&action=addfeed";

	$feed_name = stripinput($_POST['feed_name']);
	$feed_url  = stripinput($_POST['feed_url']);
	$link_name = stripinput($_POST['link_name']);
	$feed_rows = stripinput($_POST['feed_rows']);
	$cache_time= stripinput($_POST['cache_time']);
	$new_window= isset($_POST['new_window']) ? 1:0;
	$use_desc  = isset($_POST['use_desc']) ? 1:0;
	$use_fname = isset($_POST['use_fname']) ? 1:0;
	$use_pdate = isset($_POST['use_pdate']) ? 1:0;
	$use_more = isset($_POST['use_more']) ? 1:0;
	$panel_loc = isset($_POST['location']) ? stripinput($_POST['location']) : "" ;
	$panel_acc = isset($_POST['access']) ? stripinput($_POST['access']) : "" ;

	// Feed Name OK ?
	if( (strlen($feed_name) < 3) ) {
		$RSSPErrMsg .= $locale['rssp_bfname'] ."<br />";
	}

	// Feed URL OK ?
	if( (strlen($feed_url) < 10) ) {
		$RSSPErrMsg .= $locale['rssp_bfurl'] ."<br />";
	}

	// Cache Time Ok ?
	if( ($cache_time < 300) or ($cache_time > 604800) ) { // 5 Mins to 1 Week
		$RSSPErrMsg .= $locale['rssp_bfcache'] ."<br />";
	}

	if( ! $RSSPErrMsg ) {

		// Add New Feed
		$SQL = "INSERT INTO ".DB_RSSPANEL."
		(feed_name, feed_url, feed_linkname, feed_rows, feed_cache, feed_newwin, feed_show_desc, feed_show_feedname, feed_show_pubdate, feed_show_more )
		VALUES
		('$feed_name', '$feed_url', '$link_name', '$feed_rows', '$cache_time', '$new_window', '$use_desc', '$use_fname', '$use_pdate', '$use_more' )";

		$result = dbquery($SQL);

		// Find new Panel Order
		$SQL = "SELECT * FROM ".DB_PANELS." WHERE panel_side='".$panel_loc."' ORDER BY panel_order DESC LIMIT 1";
		$rssp_res = dbquery($SQL);

		if (dbrows($rssp_res) != 0) {
			$rssp_data = dbarray($rssp_res);
			$rssp_newpos = $rssp_data['panel_order'] + 1;
		} else {
			$rssp_newpos = 1;
		}

		// Create New Panel
		$SQL = "INSERT INTO ".DB_PANELS."
	        (panel_name, panel_filename, panel_content, panel_side, panel_order, panel_type, panel_access, panel_display, panel_status)
	        VALUES ('$feed_name', 'rss_parser_panel', '', '$panel_loc', '$rssp_newpos', 'file', '$panel_acc', '0', '1')";

		$result = dbquery($SQL);

		if( $result ){
			$rssp_status="&amp;status=sn";
			redirect(FUSION_SELF.$aidlink.$rssp_status);
		}else{
			redirect(FUSION_SELF.$aidlink);
		}
	}

	opentable($locale['rssp_add']);

// Display Feed for Editing
}elseif( ($action == 'edit') ){

	if( isset($_GET['feed_id'] ) ){
		$feed_id = stripinput($_GET['feed_id']);
	}else{
		redirect(FUSION_SELF.$aidlink);
	}

	$rss_formaction = FUSION_SELF.$aidlink."&action=update";

	// GET Panel Information
	$rssp_res = dbquery( "SELECT * FROM ".DB_RSSPANEL." WHERE feed_id='".$feed_id."'" );
	$rssp_data = dbarray($rssp_res);

	$feed_name = $rssp_data['feed_name'];
	$feed_url = $rssp_data['feed_url'];
	$link_name = $rssp_data['feed_linkname'];
	$feed_rows = $rssp_data['feed_rows'];
	$cache_time = $rssp_data['feed_cache'];
	$new_window = $rssp_data['feed_newwin'] ? "checked='checked' " : "";
	$use_desc = $rssp_data['feed_show_desc'] ? "checked='checked' " : "";
	$use_fname = $rssp_data['feed_show_feedname'] ? "checked='checked' " : "";
	$use_pdate = $rssp_data['feed_show_pubdate'] ? "checked='checked' " : "";
	$use_more = $rssp_data['feed_show_more'] ? "checked='checked' " : "";

	// Get Current Panel Location / Access
	$rssp_res = dbquery( "SELECT * FROM ".DB_PANELS." WHERE panel_name='".$feed_name."' AND panel_filename = 'rss_parser_panel'" );
	$rssp_data = dbarray($rssp_res);
	$loc = $rssp_data['panel_side'];
	$access = $rssp_data['panel_access'];

	$readonly = " disabled='disabled' ";
	$noedit = str_replace("[PANEL_EDITOR]", "<a href='".BASEDIR."administration/panels.php".$aidlink
	."'>".$locale['rssp_131']."</a>", $locale['rssp_noedit']);

	opentable($locale['rssp_edit']);

// Display Add Feed Form
}else{
	$rss_formaction = FUSION_SELF.$aidlink."&action=addfeed";

	$feed_name='';
	$feed_url='http://';
	$link_name='';
	$feed_rows='5';
	$cache_time='3600';
	$new_window=" checked='checked' ";
	$use_desc=" checked='checked' ";
	$use_fname=" checked='checked' ";
	$use_pdate=" checked='checked' ";
	$use_more=" checked='checked' ";
	$loc=1;		// Left Panel
	$access=102;	// Admin
	$readonly='';
	$noedit='';

	opentable($locale['rssp_add']);
}

$loc1 = ($loc==1) ? " selected='selected'" :"";
$loc2 = ($loc==2) ? " selected='selected'" :"";
$loc3 = ($loc==3) ? " selected='selected'" :"";
$loc4 = ($loc==4) ? " selected='selected'" :"";

echo "<form name='addfeed' method='post' action='".$rss_formaction."'>\n";

if( isset($action) and ( ($action == 'edit') or ($action == 'update') ) and $feed_id ){
	echo "<input type='hidden' name='feed_id' value='".$feed_id."'>\n";
}

echo "<table align='center' cellspacing='1' cellpadding='0' class='tbl-border'>\n";

// Build List of Access Options.
$access_opts = "";
$user_groups = getusergroups();
while(list($key, $user_group) = each($user_groups)){
	$sel = ($access == $user_group['0'] ? " selected='selected'" : "");
	$access_opts .= "<option value='".$user_group['0']."'$sel>".$user_group['1']."</option>\n";
}

echo "	<tr>
	<td class='tbl1'>".$locale['rssp_120']."</td>
	<td class='tbl1'><input type='text' name='feed_name' maxlength='30' value='".$feed_name."' class='textbox' style='width:150px;' title='".$locale['rssp_120b']."'></td>
	<td class='tbl1'>".$locale['rssp_120a']."</td>
	</tr>

	<tr>
	<td class='tbl1'>".$locale['rssp_121']."</td>
	<td class='tbl1' colspan='2'><input type='text' name='feed_url' maxlength='512' value='".$feed_url."' class='textbox' style='width:350px;'title='".$locale['rssp_121b']."'></td>
	</tr>

	<tr>
	<td class='tbl1'>".$locale['rssp_122']."</td>
	<td class='tbl1'><input type='text' name='link_name' maxlength='30' value='".$link_name."' class='textbox' style='width:120px;' title='".$locale['rssp_122b']."'></td>
	<td class='tbl1'>".$locale['rssp_122a']."</td>
	</tr>

	<tr>
	<td class='tbl1'>".$locale['rssp_123']."</td>
	<td class='tbl1'><input type='text' size='3' maxlength='2' name='feed_rows' value='".$feed_rows."' class='textbox' title='".$locale['rssp_123b']."'></td>
	<td class='tbl1'>".$locale['rssp_123a']."</td>
	</tr>

	<tr>
	<td class='tbl1'>".$locale['rssp_124']."</td>
	<td class='tbl1'><input type='text' size='5' maxlength='5' name='cache_time' value='".$cache_time."' class='textbox' title='".$locale['rssp_124b']."'> Sekund</td>
	<td class='tbl1'>".$locale['rssp_124a']."</td>
	</tr>

	<tr>
	<td class='tbl1'>".$locale['rssp_125']."</td>
	<td class='tbl1' colspan='2'><input type='checkbox' name='new_window' class='textbox' value='1' ".$new_window."title='".$locale['rssp_125b']."'></td>
	</tr>

	<tr>
	<td class='tbl1'>".$locale['rssp_128']."</td>
	<td class='tbl1' colspan='2'><input type='checkbox' name='use_desc' class='textbox' value='1' ".$use_desc."title='".$locale['rssp_128b']."'></td>
	</tr>

	<tr>
	<td class='tbl1'>".$locale['rssp_132']."</td>
	<td class='tbl1' colspan='2'><input type='checkbox' name='use_fname' class='textbox' value='1' ".$use_fname."title='".$locale['rssp_132b']."'></td>
	</tr>

	<tr>
	<td class='tbl1'>".$locale['rssp_133']."</td>
	<td class='tbl1' colspan='2'><input type='checkbox' name='use_pdate' class='textbox' value='1' ".$use_pdate."title='".$locale['rssp_133b']."'></td>
	</tr>

	<tr>
	<td class='tbl1'>".$locale['rssp_134']."</td>
	<td class='tbl1' colspan='2'><input type='checkbox' name='use_more' class='textbox' value='1' ".$use_more."title='".$locale['rssp_134b']."'></td>
	</tr>

	<tr>
	<td class='tbl1'>".$locale['rssp_126']."</td>
	<td class='tbl1'>
		<select name='location' class='textbox'".$readonly." title='".$locale['rssp_126b']."'>
		<option value='1'".$loc1.">".$locale['rssp_left']."</option>
		<option value='2'".$loc2.">".$locale['rssp_uctr']."</option>
		<option value='3'".$loc3.">".$locale['rssp_lctr']."</option>
		<option value='4'".$loc4.">".$locale['rssp_right']."</option>
		</select>
	</td>
	<td  class='tbl1'>".$noedit."<td>
	</tr>

	<tr>
	<td class='tbl1'>".$locale['rssp_127']."</td>
	<td class='tbl1'>
		<select name='access' class='textbox'".$readonly." title='".$locale['rssp_127b']."'>".$access_opts."
		</select>
	</td>
	<td  class='tbl1'>".$noedit."<td>
	</tr>

	<tr align='center'>
	<td class='tbl1' colspan='3'><input type='submit' name='save_feed' value='".$locale['rssp_b1']."' class='button'></td>
	</tr>";

echo "</table>\n";
echo "</form>\n";

closetable();


if ($RSSPErrMsg) { echo "<div id='close-message'><div class='admin-message'>". $RSSPErrMsg. "</div></div>\n"; }


// Get Existing Feeds List from DB
$rssp_res = dbquery( "SELECT * FROM ".DB_RSSPANEL );

// Not Found
if( !$rssp_res ) {
	opentable($locale['rssp_100']);
	echo "<p>".$locale['rssp_101']."</p>";
	closetable();
}

if (dbrows($rssp_res) == 0){
	opentable($locale['rssp_100']);
	echo "<p>".$locale['rssp_101']."</p>";
	closetable();

// Display Feed Info
}else{
	opentable($locale['rssp_100']);

	echo "<table align='center' width='400' cellspacing='1' cellpadding='0' class='tbl-border'>\n";

	echo "<tr>\n";
	echo "<td class='tbl2'>".$locale['rssp_102']."</td>\n";
	echo "<td class='tbl2' colspan='3' style='text-align:center'>".$locale['rssp_103']."</td>\n";
	echo "</tr>\n";

	while( $rssp_data = dbarray($rssp_res) ){

		$edit_url = "<a href='".FUSION_SELF.$aidlink."&amp;action=edit&amp;feed_id=".$rssp_data['feed_id']
		."' title='".$locale['rssp_107']." \"".$rssp_data['feed_name']."\"'>".$rssp_data['feed_name']."</a>";

		$view_url = "<a href='".$rssp_data['feed_url']."' target='_blank' "
		." title='".$locale['rssp_104']." \"".$rssp_data['feed_name']."\"'>".$locale['rssp_104']."</a>";

		$clear_url = "<a href='".FUSION_SELF.$aidlink."&amp;action=clear&amp;feed_id=".$rssp_data['feed_id']
		."' title='".$locale['rssp_105']." \"".$rssp_data['feed_name']."\"'>".$locale['rssp_105']."</a>";

		$delete_url = "<a href='".FUSION_SELF.$aidlink."&amp;action=delete&amp;feed_id=".$rssp_data['feed_id']
		."' title='".$locale['rssp_106']." \"".$rssp_data['feed_name']."\"' onclick=\"return confirm('".$locale['rssp_106a']."');\">".$locale['rssp_106']."</a>";

		echo "<tr>\n";
		echo "<td class='tbl1'>".$edit_url."</td>\n";
		echo "<td class='tbl1'>".$view_url."</td>\n";
		echo "<td class='tbl1'>".$clear_url."</td>\n";
		echo "<td class='tbl1'>".$delete_url."</td>\n";
		echo "</tr>\n";
	}

	$clear_url = "<a href='".FUSION_SELF.$aidlink."&amp;action=clearall"
	."' title='".$locale['rssp_105']."'>".$locale['rssp_105']."</a>";

	echo "<tr><td colspan='4'><hr></td></tr>\n";
	echo "<tr><td class='tbl1'>".$locale['rssp_110']."</td>\n";
	echo "<td class='tbl1'>&nbsp;</td><td class='tbl1'>".$clear_url."</td>\n";
	echo "<td class='tbl1'>&nbsp;</td></tr>\n";

	echo "</table>\n";

	closetable();
}

require_once THEMES."templates/footer.php";

?>
